unit Crystal;

{
 Crystal Reports 4.0
 Print Engine Declarations and Constants allow access to the Crystal Reports API
 Based on CRPE.DLL for Crystal Reports Version 4.006 (NT Patched Release)
 Copyright (c) 1991-1994  Crystal Services
 Created by Mark Mamone 28/9/95
}

interface

const
     {Constant return codes}
     PE_SF_MAX_NAME_LENGTH = 50;
     PE_SF_DESCENDING = 0;
     PE_SF_ASCENDING = 1;
     PE_ERR_NOERROR = 0;
     PE_ERR_NOTENOUGHMEMORY = 500;
     PE_ERR_INVALIDJOBNO =501;
     PE_ERR_INVALIDHANDLE = 502;
     PE_ERR_STRINGTOOLONG = 503;
     PE_ERR_NOSUCHREPORT = 504;
     PE_ERR_NODESTINATION = 505;
     PE_ERR_BADFILENUMBER = 506;
     PE_ERR_BADFILENAME = 507;
     PE_ERR_BADFIELDNUMBER = 508;
     PE_ERR_BADFIELDNAME = 509;
     PE_ERR_BADFORMULANAME = 510;
     PE_ERR_BADSORTDIRECTION = 511;
     PE_ERR_ENGINENOTOPEN = 512;
     PE_ERR_INVALIDPRINTER = 513;
     PE_ERR_PRINTFILEEXISTS = 514;
     PE_ERR_BADFORMULATEXT = 515;
     PE_ERR_BADGROUPSECTION = 516;
     PE_ERR_ENGINEBUSY = 517;
     PE_ERR_BADSECTION = 518;
     PE_ERR_NOPRINTWINDOW = 519;
     PE_ERR_JOBALREADYSTARTED = 520;
     PE_ERR_BADSUMMARYFIELD = 521;
     PE_ERR_NOTENOUGHSYSRES = 522;
     PE_ERR_BADGROUPCONDITION = 523;
     PE_ERR_JOBBUSY = 524;
     PE_ERR_BADREPORTFILE = 525;
     PE_ERR_NODEFAULTPRINTER = 526;
     PE_ERR_SQLSERVERERROR = 527;
     PE_ERR_BADLINENUMBER = 528;
     PE_ERR_DISKFULL = 529;
     PE_ERR_FILEERROR = 530;
     PE_ERR_INCORRECTPASSWORD = 531;
     PE_ERR_BADDATABASEDLL = 532;
     PE_ERR_BADDATABASEFILE = 533;
     PE_ERR_ERRORINDATABASEDLL = 534;
     PE_ERR_DATABASESESSION = 535;
     PE_ERR_DATABASELOGON = 536;
     PE_ERR_DATABASELOCATION = 537;
     PE_ERR_BADSTRUCTSIZE = 538;
     PE_ERR_BADDATE = 539;
     PE_ERR_BADEXPORTDLL = 540;
     PE_ERR_ERRORINEXPORTDLL = 541;
     PE_ERR_PREVATFIRSTPAGE = 542;
     PE_ERR_NEXTATLASTPAGE = 543;
     PE_ERR_CANNOTACCESSREPORT = 544;
     PE_ERR_USERCANCELLED = 545;
     PE_ERR_OLE2NOTLOADED = 546;
     PE_ERR_BADCROSSTABGROUP = 547;
     PE_ERR_NOCTSUMMARIZEDFIELD = 548;
     PE_ERR_DESTINATIONNOTEXPORT = 549;
     PE_ERR_INVALIDPAGENUMBER = 550;
     PE_ERR_BADLABELNUMBER = 551;
     PE_ERR_NOTSTOREDPROCEDURE = 552;
     PE_ERR_INVALIDPARAMETER = 553;
     PE_ERR_GRAPHNOTFOUND = 554;
     PE_ERR_INVALIDGRAPHTYPE = 555;
     PE_ERR_INVALIDGRAPHDATA = 556;
     PE_ERR_CANNOTMOVEGRAPH = 557;
     PE_ERR_INVALIDGRAPHTEXT = 558;
     PE_ERR_INVALIDGRAPHOPT = 559;
     PE_ERR_NOTIMPLEMENTED = 999;

     {Get Version}
     PE_GV_DLL = 100;         {values for version parameter of PEGetVersion}
     PE_GV_ENGINE = 200;

     PE_JOBNOTSTARTED = 1;
     PE_JOBINPROGRESS = 2;
     PE_JOBCOMPLETED = 3;
     PE_JOBFAILED = 4;
     PE_JOBCANCELLED = 5;

     PE_SF_MAXNAMELEN = 50;
     PE_SF_DESC = 0;
     PE_SF_ASC = 1;
     PE_DLL_NAME_LEN = 64;
     PE_FULL_NAME_LEN = 256;
     PE_SIZEOF_TABLE_TYPE = 324; { # bytes in PETableType }
     PE_DT_STANDARD = 1;         { values for DBType }
     PE_DT_SQL = 2;
     PE_SESS_USERID_LEN = 128;
     PE_SESS_PASSWORD_LEN = 128;
     PE_SIZEOF_SESSION_INFO = 262;  { # bytes in PESessionInfo }
     PE_SERVERNAME_LEN = 128;
     PE_DATABASENAME_LEN = 128;
     PE_USERID_LEN = 128;
     PE_PASSWORD_LEN = 128;
     PE_SIZEOF_LOGON_INFO = 514;  { # bytes in PELogOnInfo }

     PE_FT_RECORD = 0;
     PE_FT_TABSEPARATED = 1;
     PE_FT_TEXT = 2;
     PE_FT_DIF = 3;
     PE_FT_CSV = 4;
     PE_FT_CHARSEPARATED = 5;
     PE_FT_TABFORMATTED = 6;
     PE_FIELDDELIMLEN = 17;

     PE_SIDE_BY_SIDE_BAR_GRAPH = 0;
     PE_STACKED_BAR_GRAPH = 2;
     PE_PERCENT_BAR_GRAPH = 3;
     PE_FAKED_3D_SIDE_BY_SIDE_BAR_GRAPH = 4;
     PE_FAKED_3D_STACKED_BAR_GRAPH = 5;
     PE_FAKED_3D_PERCENT_BAR_GRAPH = 6;
     PE_PIE_GRAPH = 40;
     PE_MULTIPLE_PIE_GRAPH = 42;
     PE_PROPORTIONAL_MULTI_PIE_GRAPH = 43;
     PE_LINE_GRAPH = 80;
     PE_AREA_GRAPH = 120;
     PE_THREED_BAR_GRAPH = 160;
     PE_USER_DEFINED_GRAPH = 500;
     PE_UNKNOWN_TYPE_GRAPH = 1000;

     { Graph Directions. }
     PE_GRAPH_ROWS_ONLY = 0;
     PE_GRAPH_COLS_ONLY = 1;
     PE_GRAPH_MIXED_ROW_COL = 2;
     PE_GRAPH_MIXED_COL_ROW = 3;
     PE_GRAPH_UNKNOWN_DIRECTION = 20;

     { Graph constant for rowGroupN, colGroupN, summarizedFieldN in PEGraphDataInfo }
     PE_GRAPH_DATA_NULL_SELECTION = -1;

     { Graph text max length }
     PE_GRAPH_TEXT_LEN = 128;

type
    PEJobInfo = record
        StructSize : Integer;
        NumRecordsRead : Longint;
        NumRecordsSelected : Longint;
        NumRecordsPrinted : Longint;
        DisplayPageN : Integer;
        LatestPageN : Integer;
        StartPageN : Integer;
        PrintEnded : Integer;
    end;

type
    PETableType = record
        StructSize : Integer;   {initialize to # bytes in PETableType}
        DLLName : Array[1..PE_DLL_NAME_LEN] of Char;
        DescriptiveName : Array[1.. PE_FULL_NAME_LEN] of Char;
        DBType : Integer;
    end;

type
    PESessionInfo = record
        {initialize to # bytes in PESessionInfo}
        StructSize : Integer;

        {Password is undefined when getting information from report. }
        UserID : Array[1..PE_SESS_USERID_LEN] of Char;
        Password : Array[1..PE_SESS_PASSWORD_LEN] of Char;

        { SessionHandle is undefined when getting information from report.
          When setting information, if it is = 0 the UserID and Password
          settings are used, otherwise the SessionHandle is used. }
        SessionHandle : Longint;
    end;

type
    PELogOnInfo = record

        { initialize to # bytes in PELogOnInfo }
        StructSize : Integer;

        {For any of the following values an empty string ("") means to use
         the value already set in the report.  To override a value in the
         report use a non-empty string (e.g. "Server A").

         For Netware SQL, pass the dictionary path name in ServerName and
         data path name in DatabaseName. }

        ServerName : Array[1..PE_SERVERNAME_LEN] of Char;
        DatabaseName  : Array [1..PE_DATABASENAME_LEN] of Char;
        UserID : Array[1..PE_USERID_LEN] of Char;

        {Password is undefined when getting information from report.}
        Password  : Array[1..PE_PASSWORD_LEN] of Char;
    end;

{ Use for all types except PE_FT_CHARSEPARATED }
type
    PEPrintFileOptions = record
        StructSize : Integer;   { initialize to # of bytes in PEPrintFileOptions }
        UseReportNumberFmt : Integer;
        UseReportDateFormat : Integer;
    end;

{ Use for PE_FT_CHARSEPARATED }
type
    PECharSepFileOptions = record
        StructSize : Integer;   { initialize to # of bytes in PECharSepFileOptions }
        UseReportNumberFmt : Integer;
        UseReportDateFormat : Integer;
        StringDelimiter : Char;
        FieldDelimiter : Array[1..PE_FIELDDELIMLEN] of Char;
    end;

const
     PE_TABLE_LOCATION_LEN = 256;
     PE_SIZEOF_TABLE_LOCATION = 258;  { # bytes in PETableLocation }

type
    PETableLocation = record
        {initialize to # bytes in PETableLocation}
        StructSize : Integer;
        Location  : Array[1..PE_TABLE_LOCATION_LEN] of Char;
    end;

type
    PEExportOptions = record
        StructSize : Integer;   {initialize to # bytes in PEExportOptions}
        FormatDLLName : Array[1..PE_DLL_NAME_LEN] of Char;
        FormatType : Longint;
        FormatOptions : Longint;

        DestinationDLLName : Array[1..PE_DLL_NAME_LEN] of Char;
        DestinationType : Longint;
        DestinationOptions : Longint;

        { following are set by PEGetExportOptions,
          and ignored by PEGetExportOptions }
        NFormatOptionsBytes : Integer;
        NDestinationOptionsBytes : Integer;
    end;

type
    PEGraphDataInfo = record
        StructSize        : Integer; { initialize to # bytes in PEGraphDataInfo }
        RowGroupN         : Integer; { group number in report. }
        ColGroupN         : Integer; { group number in report. }
        SummarizedFieldN  : Integer; { summarized field number for the group
                                      where the graph stays. }
        GraphDirection    : Integer; { For normal group/total report, the direction,
                                       is always GRAPH_MIXED_ROW_COL.  For CrossTab
                                       report all four options will change the
                                       graph data. }
    end;

type
    PEGraphTextInfo = record
        StructSize        : Integer;  { initialize to # bytes in PEGraphTextInfo }
        GraphTitle        : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphSubTitle     : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphFootNote     : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphGroupsTitle  : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphSeriesTitle  : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphXAxisTitle   : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphYAxisTitle   : Array[1..PE_GRAPH_TEXT_LEN] of Char;
        GraphZAxisTitle   : Array[1..PE_GRAPH_TEXT_LEN] of Char;
    end;

type
    PEGraphOptions = record
        StructSize     : Integer; { initialize to # bytes in PEGraphOptions }
        GraphMaxValue  : Double;
        GraphMinValue  : Double;
        ShowDataValue  : Integer; { Show data values on risers. }
        ShowGridLine   : Integer;
        VerticalBars   : Integer;
        ShowLegend     : Integer;
        FontFaceName   : Array[1..PE_GRAPH_TEXT_LEN] of Char;
    end;


{Export functions for Crystal Reports}
function OpenEngine : Integer;
procedure CloseEngine;
function OpenPrintJob(ReportName : PChar) : Integer;
procedure ClosePrintJob(PrintJob : Integer);
function StartPrintJob(PrintJob, WaitOrNot : Integer) : Integer;
procedure CancelPrintJob(PrintJob : Integer);
function IsPrintJobFinished(PrintJob : Integer) : Integer;
function GetJobStatus(PrintJob : Integer; var JobInfo : PEJobInfo) : Integer;
function GetErrorCode (PrintJob : Integer) : Integer;
function GetErrorText (PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
function GetHandleString(TextHandle : Integer; Buffer : PChar; BufferLength : Integer) : Integer;
function GetPrintDate(PrintJob : Integer; var Date_Year, Date_Month, Date_Day : Integer) : Integer;
function SetPrintDate(PrintJob, Date_Year, Date_Month, Date_Day : Integer) : Integer;
function GetNFormulas(PrintJob : Integer) : Integer;
function GetNthFormula(PrintJob, FormulaN : Integer; var NameHandle, NameLength,
                       TextHandle, TextLength : Integer) : Integer;
function GetFormula(PrintJob : Integer; FormulaName : PChar;
                    var TextHandle, TextLength : Integer) : Integer;
function SetFormula(PrintJob : Integer; FormulaName, FormulaString : PChar) : Integer;
function CheckFormula(PrintJob : Integer; FormulaName : PChar) : Integer;
function GetSelectionFormula(PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
function SetSelectionFormula(PrintJob : Integer; FormulaString : PChar) : Integer;
function CheckSelectionFormula(PrintJob : Integer) : Integer;
function GetGroupSelectionFormula(PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
function SetGroupSelectionFormula(PrintJob : Integer; Formula : PChar) : Integer;
function CheckGroupSelectionFormula(PrintJob : Integer) : Integer;
function GetNSortFields(PrintJob : Integer) : Integer;
function GetNthSortField(PrintJob, SortNumber : Integer; var NameHandle, NameLength, Direction : Integer) : Integer;
function SetNthSortField(PrintJob, SortNumber : Integer; SortFieldName : PChar; Direction : Integer) : Integer;
function DeleteNthSortField(PrintJob, SortFieldN : Integer) : Integer;
function GetNGroupSortFields(PrintJob : Integer) : Integer;
function GetNthGroupSortField(PrintJob, SortFieldN : Integer; var NameHandle, NameLength, Direction : Integer) : Integer;
function SetNthGroupSortField(PrintJob, SortFieldN : Integer; SortGroupName : PChar; Direction : Integer) : Integer;
function GetNTables(PrintJob : Integer) : Integer;
function GetNthTableType(PrintJob, TableN : Integer; var TableType : PETableType) : Integer;
function GetNthTableSessionInfo(PrintJob, TableN : Integer; var SessionInfo : PESessionInfo) : Integer;
function SetNthTableSessionInfo(PrintJob, TableN : Integer; var SessionInfo : PESessionInfo;
                                PropagateAcrossTables : Integer) : Integer;
function GetNthTableLogOnInfo(PrintJob, TableN : Integer; var LogOnInfo : PELogOnInfo) : Integer;
function SetNthTableLogOnInfo(PrintJob, TableN : Integer; var LogOnInfo : PELogOnInfo; Propagate : Integer) : Integer;
function GetNthTableLocation(PrintJob, TableN : Integer; var Location : PETableLocation) : Integer;
function SetNthTableLocation(PrintJob, TableN : Integer; var Location : PETableLocation) : Integer;
function TestNthTableConnectivity(PrintJob, TableN : Integer) : Integer;
function LogOnServer ( DLLName : PChar; var LogOnInfo : PELogOnInfo) : Integer;
function LogOffServer( DLLName : PChar; var LogOnInfo : PELogOnInfo) : Integer;
function GetSQLQuery(PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
function SetSQLQuery(PrintJob : Integer; QueryString : PChar) : Integer;
function HasSavedData(PrintJob : Integer; var HasSavedData : Integer) : Integer;
function DiscardSavedData(PrintJob : Integer) : Integer;
function OutputToWindow(PrintJob : Integer; Title : PChar; Lft, Top, Wdth, Height : Integer;
                        Style : Longint; hWindow: Integer) : Integer;
function GetWindowHandle(PrintJob : Integer) : Integer;
procedure CloseWindow(PrintJob : Integer);
function SelectPrinter(PrintJob : Integer; PrinterDriver, PrinterName : PChar; DevMode : LongInt ) : Integer;
function GetSelectedPrinter(PrintJob : Integer; var DriverHandle, DriverLength,PrinterHandle, PrinterLength,
                              PortHandle, PortLength : Integer; DevMode : LongInt) : Integer;
function OutputToPrinter(PrintJob, NCopies : Integer) : Integer;
function OutputToFile(PrintJob : Integer; OutputFilePath : PChar; FileType : Integer; Options : Pointer) : Integer;
function GetExportOptions(PrintJob : Integer; var ExportOptions : PEExportOptions) : Integer;
function ExporTo(PrintJob : Integer; var ExportOptions : PEExportOptions) : Integer;
function GetGraphType(PrintJob, SectionCode, GraphN : Integer; var GraphType : Integer) : Integer;
function GetGraphData(PrintJob, SectionCode, GraphN : Integer; var GraphDataInfo : PEGraphDataInfo) : Integer;
function GetGraphText(PrintJob, SectionCode, GraphN : Integer; var GraphTextInfo : PEGraphTextInfo) : Integer;
function GetGraphOptions(PrintJob, SectionCode, GraphN : Integer; var GraphOptions : PEGraphOptions) : Integer;
function SetGraphType(PrintJob, SectionCode, GraphN : Integer; var GraphType : Integer) : Integer;
function SetGraphData(PrintJob, SectionCode, GraphN : Integer; var GraphDataInfo : PEGraphDataInfo) : Integer;
function SetGraphText(PrintJob, SectionCode, GraphN : Integer; var GraphTextInfo : PEGraphTextInfo) : Integer;
function SetGraphOptions(PrintJob, SectionCode, GraphN : Integer; var GraphOptions : PEGraphOptions) : Integer;
procedure GetCrystalReportsError(hJob : Integer; var ErrorCode : Integer; ErrorText : PChar; var ErrorTextLength : Integer);

implementation

{ Open, print and close report (used when no changes needed to report) }
function PEPrintReport (ReportFilePath : PChar; Printer, Window : Integer; Title : PChar; Left,Top,Width,Height : Integer;
                        Style : Longint; hWindow : Integer) : Integer; far; external 'CRPE';

{Open and close print engine}
function PEOpenEngine : Integer; far; external 'CRPE';
procedure PECloseEngine; far; external 'CRPE';

function PEGetVersion (Version : Integer) : Integer; far; external 'CRPE';

{Open and close print job (i.e. report) }
function PEOpenPrintJob (ReportName : PChar) : Integer; far; external 'CRPE';
procedure PEClosePrintJob (PrintJob : Integer); far; external 'CRPE';

{Start and cancel print job (i.e. print the report, usually after changing report) }
function PEStartPrintJob (PrintJob, WaitOrNot : Integer) : Integer; far; external 'CRPE';
procedure PECancelPrintJob (PrintJob : Integer); far; external 'CRPE';

{Print job status}
function PEIsPrintJobFinished (PrintJob : Integer) : Integer; far; external 'CRPE';

function PEGetJobStatus (PrintJob : Integer; var JobInfo : PEJobInfo) : Integer; far; external 'CRPE';

{Print job error codes and messages}
function PEGetErrorCode (PrintJob : Integer) : Integer; far; external 'CRPE';
function PEGetErrorText (PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer; far; external 'CRPE';
function PEGetHandleString (TextHandle : Integer; Buffer : PChar; BufferLength : Integer) : Integer; far; external 'CRPE';

{Setting the print date}
function PEGetPrintDate(PrintJob : Integer; var Date_Year, Date_Month, Date_Day : Integer) : Integer; far; external 'CRPE';
function PESetPrintDate(PrintJob, Date_Year, Date_Month, Date_Day : Integer) : Integer; far; external 'CRPE';


{Controlling formulas, selection formulas and group selection formulas}
function PEGetNFormulas (PrintJob : Integer) : Integer; far; external 'CRPE';
function PEGetNthFormula (PrintJob, FormulaN : Integer; var NameHandle, NameLength,
                          TextHandle, TextLength : Integer) : Integer; far; external 'CRPE';
function PEGetFormula (PrintJob : Integer; FormulaName : PChar;
                       var TextHandle, TextLength : Integer) : Integer; far; external 'CRPE';
function PESetFormula (PrintJob : Integer; FormulaName, FormulaString : PChar) : Integer; far; external 'CRPE';
function PECheckFormula (PrintJob : Integer; FormulaName : PChar) : Integer; far; external 'CRPE';
function PEGetSelectionFormula (PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer; far; external 'CRPE';
function PESetSelectionFormula (PrintJob : Integer; FormulaString : PChar) : Integer; far; external 'CRPE';
function PECheckSelectionFormula (PrintJob : Integer) : Integer; far; external 'CRPE';
function PEGetGroupSelectionFormula (PrintJob : Integer;
                                     var TextHandle, TextLength : Integer) : Integer; far; external 'CRPE';
function PESetGroupSelectionFormula (PrintJob : Integer; Formula : PChar) : Integer; far; external 'CRPE';
function PECheckGroupSelectionFormula (PrintJob : Integer) : Integer; far; external 'CRPE';

{Controlling sort order and group sort order}

function PEGetNSortFields (PrintJob : Integer) : Integer; far; external 'CRPE';
function PEGetNthSortField (PrintJob, SortNumber : Integer;
                            var NameHandle, NameLength, Direction : Integer) : Integer; far; external 'CRPE';
function PESetNthSortField (PrintJob, SortNumber : Integer;
                            SortFieldName : PChar; Direction : Integer) : Integer; far; external 'CRPE';
function PEDeleteNthSortField (PrintJob, SortFieldN : Integer) : Integer; far; external 'CRPE';
function PEGetNGroupSortFields (PrintJob : Integer) : Integer; far; external 'CRPE';
function PEGetNthGroupSortField (PrintJob, SortFieldN : Integer;
                                 var NameHandle, NameLength, Direction : Integer) : Integer; far; external 'CRPE';
function PESetNthGroupSortField (PrintJob, SortFieldN : Integer;
                                 SortGroupName : PChar; Direction : Integer) : Integer; far; external 'CRPE';
function PEDeleteNthGroupSortField (PrintJob, SortFieldN : Integer) : Integer; far; external 'CRPE';

{ Controlling databases
  ---------------------

  The following functions allow retrieving and updating database info
  in an opened report, so that a report can be printed using different
  session, server, database, user and/or table location settings.  Any
  changes made to the report via these functions are not permanent, and
  only last as long as the report is open.

  The following database functions (except for PELogOnServer and
  PELogOffServer) must be called after PEOpenPrintJob and before
  PEStartPrintJob.

  The function PEGetNTables is called to fetch the number of tables in
  the report.  This includes all PC databases (e.g. Paradox, xBase)
  as well as SQL databases (e.g. SQL Server, Oracle, Netware). }

function PEGetNTables (PrintJob : Integer) : Integer; far; external 'CRPE';


{ The function PEGetNthTableType allows the application to determine the
  type of each table.  The application can test DBType (equal to
  PE_DT_STANDARD or PE_DT_SQL), or test the database DLL name used to
  create the report.  DLL names have the following naming convention:
      - PDB*.DLL for standard (non-SQL) databases,
      - PDS*.DLL for SQL databases.

  In the case of ODBC (PDSODBC.DLL) the DescriptiveName includes the
  ODBC data source name. }

function PEGetNthTableType (PrintJob, TableN : Integer; var TableType : PETableType) : Integer; far; external 'CRPE';

{ The functions PEGetNthTableSessionInfo and PESetNthTableSessionInfo
  are only used when connecting to MS Access databases (which require a
  session to be opened first) }

function PEGetNthTableSessionInfo (PrintJob, TableN : Integer;
                                   var SessionInfo : PESessionInfo) : Integer; far; external 'CRPE';
function PESetNthTableSessionInfo (PrintJob, TableN : Integer; var SessionInfo : PESessionInfo;
                                   PropagateAcrossTables : Integer) : Integer; far; external 'CRPE';

{ Logging on is performed when printing the report, but the correct
  log on information must first be set using PESetNthTableLogOnInfo.
  Only the password is required, but the server, database, and
  user names may optionally be overriden as well.

  If the parameter propagateAcrossTables is TRUE, the new log on info
  is also applied to any other tables in this report that had the
  same original server and database names as this table.  If FALSE
  only this table is updated.

  Logging off is performed automatically when the print job is closed. }

function PEGetNthTableLogOnInfo (PrintJob, TableN : Integer; var LogOnInfo : PELogOnInfo) : Integer; far; external 'CRPE';
function PESetNthTableLogOnInfo (PrintJob, TableN : Integer;
                                 var LogOnInfo : PELogOnInfo; Propagate : Integer) : Integer; far; external 'CRPE';

{ A table's location is fetched and set using PEGetNthTableLocation and
  PESetNthTableLocation.  This name is database-dependent, and must be
  formatted correctly for the expected database.  For example:
      - Paradox: "c:\crw\ORDERS.DB"
      - SQL Server: "publications.dbo.authors" }

function PEGetNthTableLocation(PrintJob, TableN : Integer; var Location : PETableLocation) : Integer; far; external 'CRPE';
function PESetNthTableLocation(PrintJob, TableN : Integer; var Location : PETableLocation) : Integer; far; external 'CRPE';

{ The function PETestNthTableConnectivity tests whether a database
  table's settings are valid and ready to be reported on.  It returns
  true if the database session, log on, and location info is all
  correct.

  This is useful, for example, in prompting the user and testing a
  server password before printing begins.

  This function may require a significant amount of time to complete,
  since it will first open a user session (if required), then log onto
  the database server (if required), and then open the appropriate
  database table (to test that it exists).  It does not read any data,
  and closes the table immediately once successful.  Logging off is
  performed when the print job is closed.

  If it fails in any of these steps, the error code set indicates
  which database info needs to be updated using functions above:
     - If it is unable to begin a session, PE_ERR_DATABASESESSION is set,
       and the application should update with PESetNthTableSessionInfo.
     - If it is unable to log onto a server, PE_ERR_DATABASELOGON is set,
       and the application should update with PESetNthTableLogOnInfo.
     - If it is unable open the table, PE_ERR_DATABASELOCATION is set,
       and the application should update with PESetNthTableLocation. }

function PETestNthTableConnectivity (PrintJob, TableN : Integer) : Integer; far; external 'CRPE';

{ PELogOnServer and PELogOffServer can be called at any time to log on
  and off of a database server.  These functions are not required if
  function PESetNthTableLogOnInfo above was already used to set the
  password for a table.

  These functions require a database DLL name, which can be retrieved
  using PEGetNthTableType above.

  This function can also be used for non-SQL tables, such as password-
  protected Paradox tables.  Call this function to set the password
  for the Paradox DLL before beginning printing.

  Note: When printing using PEStartPrintJob the ServerName passed in
  PELogOnServer must agree exactly with the server name stored in the
  report.  If this is not true use PESetNthTableLogOnInfo to perform
  logging on instead. }

function PELogOnServer ( DLLName : PChar; var LogOnInfo : PELogOnInfo) : Integer; far; external 'CRPE';
function PELogOffServer ( DLLName : PChar; var LogOnInfo : PELogOnInfo) : Integer; far; external 'CRPE';

{ Overriding SQL query in report
  ------------------------------

  PEGetSQLQuery returns the same query as appears in the Show SQL Query
  dialog in CRW, in syntax specific to the database driver you are using.

  PESetSQLQuery is mostly useful for reports with SQL queries that
  were explicitly edited in the Show SQL Query dialog in CRW, i.e. those
  reports that needed database-specific selection criteria or joins.
  (Otherwise it is usually best to continue using function calls such as
  PESetSelectionFormula and let CRW build the SQL query automatically.)

  PESetSQLQuery has the same restrictions as editing in the Show SQL
  Query dialog; in particular that changes are accepted in the FROM and
  WHERE clauses but ignored in the SELECT list of fields. }

function PEGetSQLQuery (PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer; far; external 'CRPE';
function PESetSQLQuery (PrintJob : Integer; QueryString : PChar) : Integer; far; external 'CRPE';

{ Saved data
  ----------

  Use PEHasSavedData to find out if a report currently has saved data
  associated with it.  This may or may not be TRUE when a print job is
  first opened from a report file.  Since data is saved during a print,
  this will always be TRUE immediately after a report is printed.

  Use PEDiscardSavedData to release the saved data associated with a
  report.  The next time the report is printed, it will get current data
  from the database.

  The default behavior is for a report to use its saved data, rather than
  refresh its data from the database when printing a report. }

function PEHasSavedData (PrintJob : Integer; var HasSavedData : Integer) : Integer; far; external 'CRPE';
function PEDiscardSavedData (PrintJob : Integer) : Integer; far; external 'CRPE';

{ Controlling print to window
  --------------------------- }

function PEOutputToWindow (PrintJob : Integer; Title : PChar; Lft, Top, Wdth, Height : Integer;
                           Style : Longint; hWindow: Integer) : Integer; far; external 'CRPE';
function PEGetWindowHandle (PrintJob : Integer) : Integer; far; external 'CRPE';
function PEPrintWindow (PrintJob, WaitNoWait : Integer) : Integer; far; external 'CRPE';
procedure PECloseWindow (PrintJob : Integer); far; external 'CRPE';


{ Changing printer selection
  -------------------------- }

function PESelectPrinter (PrintJob : Integer; PrinterDriver, PrinterName : PChar;
                          DevMode : LongInt ) : Integer; far; external 'CRPE';
function PEGetSelectedPrinter(PrintJob : Integer; var DriverHandle, DriverLength,PrinterHandle, PrinterLength,
                              PortHandle, PortLength : Integer; DevMode : LongInt) : Integer; far; external 'CRPE';

{ Controlling print to printer
  ---------------------------- }

function PEOutputToPrinter (PrintJob, NCopies : Integer) : Integer; far; external 'CRPE';

{ Controlling print to file and export
  ------------------------------------ }

function PEOutputToFile(PrintJob : Integer; OutputFilePath : PChar;
                        FileType : Integer; Options : Pointer) : Integer ; far; external 'CRPE';

function PEGetExportOptions (PrintJob : Integer; var ExportOptions : PEExportOptions) : Integer; far; external 'CRPE';
function PEExporTo (PrintJob : Integer; var ExportOptions : PEExportOptions) : Integer; far; external 'CRPE';


{ Setting Graph/Chart info
  ------------------------

  Two parameters are passed to uniquely identify the graph:
       - section code
       - graph number in that section

  The section code includes whether it is a header or footer, and the
  graph number starts at 0, 1...  The graph number identifies the graph
  by its position in the section
       - looking top down first,
       - then left to right if they have the same top. }

{ Graph Types }

function PEGetGraphType (PrintJob, SectionCode, GraphN : Integer; var GraphType : Integer) : Integer; far; external 'CRPE';
function PEGetGraphData (PrintJob, SectionCode, GraphN : Integer;
                         var GraphDataInfo : PEGraphDataInfo) : Integer; far; external 'CRPE';
function PEGetGraphText (PrintJob, SectionCode, GraphN : Integer;
                         var GraphTextInfo : PEGraphTextInfo) : Integer; far; external 'CRPE';
function PEGetGraphOptions (PrintJob, SectionCode, GraphN : Integer;
                         var GraphOptions : PEGraphOptions) : Integer; far; external 'CRPE';

function PESetGraphType (PrintJob, SectionCode, GraphN : Integer;
                         var GraphType : Integer) : Integer; far; external 'CRPE';
function PESetGraphData (PrintJob, SectionCode, GraphN : Integer;
                         var GraphDataInfo : PEGraphDataInfo) : Integer; far; external 'CRPE';
function PESetGraphText (PrintJob, SectionCode, GraphN : Integer;
                         var GraphTextInfo : PEGraphTextInfo) : Integer; far; external 'CRPE';
function PESetGraphOptions (PrintJob, SectionCode, GraphN : Integer;
                         var GraphOptions : PEGraphOptions) : Integer; far; external 'CRPE';

{ End Of Declarations }
{ Exported code for this unit, Delphi Units including this Unit can call these routines }

function OpenEngine : Integer;
begin
     {Call .DLL implementation}
     OpenEngine := PEOpenEngine;
end;

procedure CloseEngine;
begin
     {Call .DLL implementation}
     PECloseEngine;
end;

function OpenPrintJob(ReportName : PChar) : Integer;
begin
     {Call .DLL implementation}
     OpenPrintJob := PEOpenPrintJob(ReportName);
end;

procedure ClosePrintJob(PrintJob : Integer);
begin
     {Call .DLL implementation}
     PEClosePrintJob(PrintJob);
end;

function StartPrintJob(PrintJob, WaitOrNot : Integer) : Integer;
begin
     {Call .DLL implementation}
     StartPrintJob := PEStartPrintJob(PrintJob, WaitOrNot);
end;

procedure CancelPrintJob(PrintJob : Integer);
begin
     {Call .DLL implementation}
     PECancelPrintJob(PrintJob);
end;

function IsPrintJobFinished(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     IsPrintJobFinished := PEIsPrintJobFinished(PrintJob);
end;

function GetJobStatus(PrintJob : Integer; var JobInfo : PEJobInfo) : Integer;
begin
     {Call .DLL implementation}
     GetJobStatus := PEGetJobStatus(PrintJob, JobInfo);
end;

function GetErrorCode (PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetErrorCode := PEGetErrorCode(PrintJob);
end;

function GetErrorText (PrintJob : Integer; Var TextHandle, TextLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetErrorText := PEGetErrorText(PrintJob, TextHandle, TextLength);
end;

function GetHandleString(TextHandle : Integer; Buffer : PChar; BufferLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetHandleString := PEGetHandleString(TextHandle, Buffer, BufferLength);
end;

function GetPrintDate(PrintJob : Integer; var Date_Year, Date_Month, Date_Day : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetPrintDate := PEGetPrintDate(PrintJob, Date_Year, Date_Month, Date_Day);
end;

function SetPrintDate(PrintJob, Date_Year, Date_Month, Date_Day : Integer) : Integer;
begin
     {Call .DLL implementation}
     SetPrintDate := PESetPrintDate(PrintJob, Date_Year, Date_Month, Date_Day);
end;


function GetNFormulas(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNFormulas := PEGetNFormulas(PrintJob);
end;


function GetNthFormula(PrintJob, FormulaN : Integer; var NameHandle, NameLength,
                       TextHandle, TextLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNthFormula := PEGetNthFormula(PrintJob, FormulaN, NameHandle, NameLength, TextHandle, TextLength);
end;

function GetFormula(PrintJob : Integer; FormulaName : PChar;
                    var TextHandle, TextLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetFormula := PEGetFormula(PrintJob, FormulaName, TextHandle, TextLength);
end;

function SetFormula(PrintJob : Integer; FormulaName, FormulaString : PChar) : Integer;
begin
     {Call .DLL implementation}
     SetFormula := PESetFormula(PrintJob, FormulaName, FormulaString);
end;

function CheckFormula(PrintJob : Integer; FormulaName : PChar) : Integer;
begin
     {Call .DLL implementation}
     CheckFormula := PECheckFormula(PrintJob, FormulaName);
end;

function GetSelectionFormula(PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetSelectionFormula := PEGetSelectionFormula(PrintJob, TextHandle, TextLength);
end;

function SetSelectionFormula(PrintJob : Integer; FormulaString : PChar) : Integer;
begin
     {Call .DLL implementation}
     SetSelectionFormula := PESetSelectionFormula(PrintJob, FormulaString);
end;

function CheckSelectionFormula(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     CheckSelectionFormula := PECheckSelectionFormula(PrintJob);
end;

function GetGroupSelectionFormula(PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetGroupSelectionFormula := PEGetGroupSelectionFormula(PrintJob, TextHandle, TextLength);
end;

function SetGroupSelectionFormula(PrintJob : Integer; Formula : PChar) : Integer;
begin
     {Call .DLL implementation}
     SetGroupSelectionFormula := PESetGroupSelectionFormula(PrintJob, Formula);
end;

function CheckGroupSelectionFormula(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     CheckGroupSelectionFormula := PECheckGroupSelectionFormula(PrintJob);
end;

function GetNSortFields(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNSortFields := PEGetNSortFields(PrintJob);
end;

function GetNthSortField(PrintJob, SortNumber : Integer; var NameHandle, NameLength, Direction : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNthSortField := PEGetNthSortField(PrintJob, SortNumber, NameHandle, NameLength, Direction);
end;

function SetNthSortField(PrintJob, SortNumber : Integer; SortFieldName : PChar; Direction : Integer) : Integer;
begin
     {Call .DLL implementation}
     SetNthSortField := PESetNthSortField(PrintJob, SortNumber, SortFieldName, Direction);
end;

function DeleteNthSortField(PrintJob, SortFieldN : Integer) : Integer;
begin
     {Call .DLL implementation}
     DeleteNthSortField := PEDeleteNthSortField(PrintJob, SortFieldN);
end;

function GetNGroupSortFields(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNGroupSortFields := PEGetNGroupSortFields(PrintJob);
end;

function GetNthGroupSortField(PrintJob, SortFieldN : Integer; var NameHandle, NameLength, Direction : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNthGroupSortField :=PEGetNthGroupSortField(PrintJob, SortFieldN, NameHandle, NameLength, Direction);
end;

function SetNthGroupSortField(PrintJob, SortFieldN : Integer; SortGroupName : PChar; Direction : Integer) : Integer;
begin
     {Call .DLL implementation}
     SetNthGroupSortField := PESetNthGroupSortField(PrintJob, SortFieldN, SortGroupName, Direction);
end;

function DeleteNthGroupSortField(PrintJob, SortFieldN : Integer) : Integer;
begin
     {Call .DLL implementation}
     DeleteNthGroupSortField := PEDeleteNthGroupSortField(PrintJob, SortFieldN);
end;

function GetNTables(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetNTables := PEGetNTables(PrintJob);
end;

function GetNthTableType(PrintJob, TableN : Integer; var TableType : PETableType) : Integer;
begin
     {Call .DLL implementation}
     GetNthTableType := PEGetNthTableType(PrintJob, TableN, TableType);
end;

function GetNthTableSessionInfo(PrintJob, TableN : Integer; var SessionInfo : PESessionInfo) : Integer;
begin
     {Call .DLL implementation}
     GetNthTableSessionInfo := PEGetNthTableSessionInfo(PrintJob, TableN, SessionInfo);
end;

function SetNthTableSessionInfo(PrintJob, TableN : Integer; var SessionInfo : PESessionInfo;
                                PropagateAcrossTables : Integer) : Integer;
begin
     {Call .DLL implementation}
     SetNthTableSessionInfo := PESetNthTableSessionInfo(PrintJob, TableN, SessionInfo, PropagateAcrossTables);
end;

function GetNthTableLogOnInfo(PrintJob, TableN : Integer; var LogOnInfo : PELogOnInfo) : Integer;
begin
     {Call .DLL implementation}
     GetNthTableLogOnInfo := PEGetNthTableLogOnInfo(PrintJob, TableN, LogOnInfo);
end;

function SetNthTableLogOnInfo(PrintJob, TableN : Integer; var LogOnInfo : PELogOnInfo; Propagate : Integer) : Integer;
begin
     {Call .DLL implementation}
     SetNthTableLogOnInfo := PESetNthTableLogOnInfo(PrintJob, TableN, LogOnInfo, Propagate);
end;

function GetNthTableLocation(PrintJob, TableN : Integer; var Location : PETableLocation) : Integer;
begin
     {Call .DLL implementation}
     GetNthTableLocation := PEGetNthTableLocation(PrintJob, TableN, Location);
end;

function SetNthTableLocation(PrintJob, TableN : Integer; var Location : PETableLocation) : Integer;
begin
     {Call .DLL implementation}
     SetNthTableLocation := PESetNthTableLocation(PrintJob, TableN, Location);
end;

function TestNthTableConnectivity(PrintJob, TableN : Integer) : Integer;
begin
     {Call .DLL implementation}
     TestNthTableConnectivity := PETestNthTableConnectivity(PrintJob, TableN);
end;

function LogOnServer( DLLName : PChar; var LogOnInfo : PELogOnInfo) : Integer;
begin
     {Call .DLL implementation}
     LogOnServer := PELogOnServer(DLLName, LogOnInfo);
end;

function LogOffServer( DLLName : PChar; var LogOnInfo : PELogOnInfo) : Integer;
begin
     {Call .DLL implementation}
     LogOffServer := PELogOffServer(DLLName, LogOnInfo);
end;

function GetSQLQuery(PrintJob : Integer; var TextHandle, TextLength : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetSQLQuery := PEGetSQLQuery(PrintJob, TextHandle, TextLength);
end;

function SetSQLQuery(PrintJob : Integer; QueryString : PChar) : Integer;
begin
     {Call .DLL implementation}
     SetSQLQuery := PESetSQLQuery(PrintJob, QueryString);
end;

function HasSavedData(PrintJob : Integer; var HasSavedData : Integer) : Integer;
begin
     {Call .DLL implementation}
     HasSavedData := PEHasSavedData(PrintJob, HasSavedData);
end;

function DiscardSavedData(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     DiscardSavedData := PEDiscardSavedData(PrintJob);
end;

function OutputToWindow(PrintJob : Integer; Title : PChar; Lft, Top, Wdth, Height : Integer;
                        Style : Longint; hWindow: Integer) : Integer;
begin
     {Call .DLL implementation}
     OutputToWindow := PEOutputToWindow(PrintJob, Title, Lft, Top, Wdth, Height, Style, hWindow);
end;

function GetWindowHandle(PrintJob : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetWindowHandle := PEGetWindowHandle(PrintJob);
end;

function PrintWindow(PrintJob, WaitNoWait : Integer) : Integer;
begin
     {Call .DLL implementation}
     PrintWindow := PEPrintWindow(PrintJob, WaitNoWait);
end;

procedure CloseWindow(PrintJob : Integer);
begin
     PECloseWindow(PrintJob);
end;

function SelectPrinter(PrintJob : Integer; PrinterDriver, PrinterName : PChar; DevMode : LongInt ) : Integer;
begin
     {Call .DLL implementation}
     SelectPrinter := PESelectPrinter(PrintJob, PrinterDriver, PrinterName, DevMode);
end;

function GetSelectedPrinter(PrintJob : Integer; var DriverHandle, DriverLength,PrinterHandle, PrinterLength,
                              PortHandle, PortLength : Integer; DevMode : LongInt) : Integer;
begin
     {Call .DLL implementation}
     GetSelectedPrinter := PEGetSelectedPrinter(PrintJob, DriverHandle, DriverLength, PrinterHandle, PrinterLength,
                                                PortHandle, PortLength, DevMode);
end;

function OutputToPrinter(PrintJob, NCopies : Integer) : Integer;
begin
     {Call .DLL implementation}
     OutputToPrinter := PEOutputToPrinter(PrintJob, NCopies);
end;

function OutputToFile(PrintJob : Integer; OutputFilePath : PChar; FileType : Integer; Options : Pointer) : Integer;
begin
     {Call .DLL implementation}
     OutputToFile := PEOutputToFile(PrintJob, OutputFilePath, FileType, Options);
end;

function GetExportOptions(PrintJob : Integer; var ExportOptions : PEExportOptions) : Integer;
begin
     {Call .DLL implementation}
     GetExportOptions := PEGetExportOptions(PrintJob, ExportOptions);
end;

function ExporTo(PrintJob : Integer; var ExportOptions : PEExportOptions) : Integer;
begin
     {Call .DLL implmentation}
     ExporTo := PEExporTo(PrintJob, ExportOptions);
end;

function GetGraphType(PrintJob, SectionCode, GraphN : Integer; var GraphType : Integer) : Integer;
begin
     {Call .DLL implementation}
     GetGraphType := PEGetGraphType(PrintJob, SectionCode, GraphN, GraphType);
end;

function GetGraphData(PrintJob, SectionCode, GraphN : Integer; var GraphDataInfo : PEGraphDataInfo) : Integer;
begin
     {Call .DLL implementation}
     GetGraphData := PEGetGraphData(PrintJob, SectionCode, GraphN, GraphDataInfo);
end;

function GetGraphText(PrintJob, SectionCode, GraphN : Integer; var GraphTextInfo : PEGraphTextInfo) : Integer;
begin
     {Call .DLL implementation}
     GetGraphText := PEGetGraphText(PrintJob, SectionCode, GraphN, GraphTextInfo);
end;

function GetGraphOptions(PrintJob, SectionCode, GraphN : Integer; var GraphOptions : PEGraphOptions) : Integer;
begin
     {Call .DLL implementation}
     GetGraphOptions := PEGetGraphOptions(PrintJob, SectionCode, GraphN, GraphOptions);
end;

function SetGraphType(PrintJob, SectionCode, GraphN : Integer; var GraphType : Integer) : Integer;
begin
     {Call .DLL implementation}
     SetGraphType := PESetGraphType(PrintJob, SectionCode, GraphN, GraphType);
end;

function SetGraphData(PrintJob, SectionCode, GraphN : Integer; var GraphDataInfo : PEGraphDataInfo) : Integer;
begin
     {Call .DLL implementation}
     SetGraphData := PESetGraphData(PrintJob, SectionCode, GraphN, GraphDataInfo);
end;

function SetGraphText(PrintJob, SectionCode, GraphN : Integer; var GraphTextInfo : PEGraphTextInfo) : Integer;
begin
     {Call .DLL implementation}
     SetGraphText := PESetGraphText(PrintJob, SectionCode, GraphN, GraphTextInfo);
end;

function SetGraphOptions(PrintJob, SectionCode, GraphN : Integer; var GraphOptions : PEGraphOptions) : Integer;
begin
     {Call .DLL implementations}
     SetGraphOptions := PESetGraphOptions(PrintJob, SectionCode, GraphN, GraphOptions);
end;

procedure GetCrystalReportsError(hJob : Integer; var ErrorCode : Integer; ErrorText : PChar; var ErrorTextLength : Integer);
var
   hTextHandle : Integer;
begin
     {Get the Error code for the Job}
     ErrorCode := GetErrorCode(hJob);

     {Get the Error Text for the Job}
     GetErrorText(hJob, hTextHandle, ErrorTextLength);
     GetHandleString(hTextHandle, @ErrorText, SizeOf(ErrorText));

end;

end.


